import os

from conan import ConanFile
from conan.tools.cmake import CMake, cmake_layout
from conan.tools.build import can_run


class tgowtTestConan(ConanFile):
    settings = "os", "compiler", "build_type", "arch"
    generators = "CMakeDeps", "CMakeToolchain"

    def requirements(self):
        self.requires(self.tested_reference_str)
        self.requires("abseil/20240116.1@aurora")
        self.requires("crc32c/1.1.2@aurora")
        self.requires("ffmpeg/7.0.1@aurora")
        self.requires("mozjpeg/4.1.5@aurora")
        self.requires("openh264/2.5.0@aurora")
        self.requires("openssl/3.2.3@aurora")
        self.requires("opus/1.5.2@aurora")
        self.requires("libsrtp/2.5.0@aurora")
        self.requires("libvpx/1.14.1@aurora")

    def build(self):
        cmake = CMake(self)
        cmake.configure()
        cmake.build()

    def layout(self):
        cmake_layout(self)

    def test(self):
        if can_run(self):
            cmd = os.path.join(self.cpp.build.bindir, "example")
            self.run(cmd, env="conanrun")
